#pragma once
#include "dinkyecs.hpp"
#include <nlohmann/json.hpp>
#include <vector>

namespace components {
  using namespace nlohmann;

  typedef std::function<void(DinkyECS::Entity ent, json &config, DinkyECS::World &world)> Action;

  void StairsDown(DinkyECS::Entity player_ent, json &data, DinkyECS::World &world);
  void StairsUp(DinkyECS::Entity player_ent, json &data, DinkyECS::World &world);

  struct Device {
    json config;
    std::vector<Action> actions;
    void hit(DinkyECS::Entity ent, DinkyECS::World &world);
  };
}
